#include <iostream>
#include <fstream>
#include "Pokemon.h"

using namespace std;


int main(int argc, char* argv[]) {
    cout << "You passed " << argc << " command-line parameters." << endl;
    cout << "Welcome to Employee Database";
    cout << " Here is all the employee information" << endl;

    // Check if a filename is provided as a command-line parameter
        if (argc != 2) {
            cerr << "Usage: " << argv[0] << "Please enter the program name followed by the file name." << endl;
            return 1; // Return an error code
        }
    
    ifstream ifs;
    ifs.open(argv[1], ios::in);
    
    
    if (!ifs.is_open()) {
            cerr << "Error opening file: " << argv[1] << endl;
            return 1; // Return an error code
        }
    

    
    string name, jobTitle, firstLine, hireYearString, idNumberString, ageString;
    int idNumber = 0, age = 0, hireYear; //local variables assigned for each part of the line
    
    
    getline(ifs, firstLine);
    
    int numberOfEmployees = stoi(firstLine); //turn the frist line into an integer
    Employee** employeeArray = new Employee*[numberOfEmployees]; //create a array with cells equal to number of lines

    //my first for-loop reads from the file
    for (int i=0; i<numberOfEmployees; i++) {
        getline(ifs, name, '|');
        getline(ifs, idNumberString, '|');
        getline(ifs, ageString, '|');
        getline(ifs, jobTitle, '|');
        getline(ifs, hireYearString);
        
        //now I need to convert the string numbers to integers
        
        hireYear = stoi(hireYearString);
        
        idNumber = stoi(idNumberString);
        
        age = stoi(ageString);
        
        employeeArray[i] = new Employee(name, idNumber, age, jobTitle, hireYear);
        
        
    }
    
    

    
    
    

    //Insertion Sort
    
    int numOfComparisons = 0;
    for (int j = 1; j < numberOfEmployees; j++) {
        Employee* key = employeeArray[j];//key
        int i = j - 1;//index
        //Insert employeeArray[j] into sorted sequence?
        while (i >= 0 && employeeArray[i]-> getID() > key->getID()) {
            numOfComparisons++;
            employeeArray[i + 1] = employeeArray[i];
            i = i - 1;
        }
        employeeArray[i + 1] = key;

        //Prints the iterations
        /*for (int k = 0; k < numberOfEmployees; k++) {
            cout << employeeArray[k]->getID() << " ";
        }
        cout << endl;*/
        
    }
    cout << "It took " << numOfComparisons << " comparisons to sort the data." << endl;
     
    
    ofstream sortedFile("Sorted_Employee_Data.txt");
    
    if (!sortedFile.is_open()) {
            cerr << "Error opening sorted file for writing." << endl;
            return 1; // Return an error code
        }
    
    for (int i = 0; i < numberOfEmployees; i++) {
        sortedFile << employeeArray[i]->getName() << "|"
                    << employeeArray[i]->getID() << "|"
                    << employeeArray[i]->getAge() << "|"
                    << employeeArray[i]->getJob() << "|"
                    << employeeArray[i]->getHireYear() << endl;
    }
    
    sortedFile << "It took " << numOfComparisons << " comparisons to sort the data." << endl;
    sortedFile.close();


    return 0;
}

/*
 * multi
 * line
 * comment
 */
